--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    13:20:34 06/20/06
-- Design Name:    
-- Module Name:    OR_rev - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity OR_rev is
    Port ( a : in std_logic;
           b : in std_logic;
           Z : in std_logic;           -- ancilla
			  a_out : out std_logic;
			  b_out : out std_logic;
			  result : out std_logic			  
			  );
end OR_rev;

architecture Behavioral of OR_rev is

signal axorb, aandb : std_logic;

begin

a_out <= a;
b_out <= b;
axorb <= a xor b;
aandb <= (a and b) xor Z;
result <= axorb xor aandb;

end Behavioral;
